package org.example.convertidordivisas2;

import android.os.Bundle;
import android.os.StrictMode;
import android.support.v7.app.ActionBarActivity;
import android.widget.TextView;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import java.net.URL;
import java.net.URLEncoder;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * Created by jaci on 18/11/2015.
 */
public class Listado extends ActionBarActivity {

    TextView selecccion, resultados;
    private String mOrigen;
    private String[] lista = {"AUD", "BRL", "GBP", "CAD", "CNY", "EUR", "HKD", "JPY", "RUB", "USD"};


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.listado);
        //cogemos el valor de la moneda k queremos listar la monedaOrigen activa
        Bundle extras = getIntent().getExtras();
        mOrigen = (String) extras.getString("m");
        //inicializamos TextView y asignamos la moneda recibida
        selecccion = (TextView) findViewById(R.id.origenLista);
        resultados = (TextView) findViewById(R.id.lista);
        selecccion.setText(mOrigen);

        //permiso del StrictMode para acceder a internet desde la pantalla de usuario
        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitNetwork().build());
        // controlar posibles fallos
        try {
            resultadosSW2();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    //calculamos ratio para cada moneda con la seleccionada
    void resultadosSW2() throws Exception {

        for (int i = 0; i <= 10; i++) {
            // creamos la URL de la conexion URLencoder codifica las palabras en formato para servidor
            URL url = new URL("http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency="
                    + URLEncoder.encode(mOrigen, "UTF-8") + "&ToCurrency=" + URLEncoder.encode(lista[i], "UTF-8"));
            //usamos las librerias org.xml.sax para hacer Parser sobre el codigo XML de la URL cap.9
            SAXParserFactory fabrica = SAXParserFactory.newInstance();
            SAXParser parser = fabrica.newSAXParser();
            XMLReader lector = parser.getXMLReader();
            //XMLHandler
            ManejadorXML manejadorXML = new ManejadorXML();
            lector.setContentHandler(manejadorXML);
            lector.parse(new InputSource(url.openStream()));
            //getTotalResults no devuelve la informacion k nos interesa
            Double cambio = manejadorXML.getTotalResults();
            String resul = cambio.toString();
            resultados.append(resul + " " + lista[i] + "\n");
        }
    }

}

