package org.example.convertidordivisas2;

import android.content.Intent;
import android.content.SharedPreferences;
import android.media.MediaPlayer;
import android.os.StrictMode;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {
    //menu principal
    private Button bPlay, bConf, bAcercaDe, bSalir;
    TextView titulo;
    //inicializamos variables para url del webservicex desde esta actividad podemos lanzar el informe y cambiar valores moneda
    String monedaOrigen = "EUR", monedaDestino = "USD";
    // musica de fondo
    MediaPlayer mp; boolean musica; int pos;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        //inicializamos...
        titulo = (TextView) findViewById(R.id.titulo);
        bPlay = (Button) findViewById(R.id.button01);
        bPlay.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lanzarConvertidor(null);
            }
        });
        bConf = (Button) findViewById(R.id.button02);
        bConf.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lanzarPreferencias(null);
            }
        });
        bAcercaDe = (Button) findViewById(R.id.button03);
        bAcercaDe.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lanzarAcercaDe(null);
            }
        });
        bSalir = (Button) findViewById(R.id.button04);//no le he cambiado el nombre pa no marear mas.. "SCORES"
        bSalir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lanzarListado(null);
            }
        });

        //permiso del StrictMode para acceder a internet desde la pantalla de usuario
        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitNetwork().build());

        //instanciamos mp que luego usaremos para rejproducir el audio en onResume()
        mp = MediaPlayer.create(this, R.raw.audio);
    }
    // Creamos menus desde xml
    @Override public boolean onCreateOptionsMenu(Menu menu){
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }
    //Creamos los item y sus acciones
    @Override public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if (id == R.id.action_settings) {
            lanzarPreferencias(null);
            return true;
        }

        if (id == R.id.acercaDe) {
            lanzarAcercaDe(null);
            return true;
        }

        if (id == R.id.listaDe) {
            lanzarListado(null);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }
    //metodos para lanzar actividades
    public void lanzarPreferencias(View view) {
        Intent i =new Intent(this, Preferencias.class);
        startActivity(i);
    }
    public void lanzarAcercaDe(View view){
        Intent i = new Intent(this, AcercaDe.class);
        startActivity(i);
    }
    public void lanzarListado(View view){
        String envio = monedaOrigen;
        Intent i = new Intent(this, Listado.class);
        i.putExtra("m", envio);
        startActivity(i);
    }
    public void lanzarConvertidor(View view){
        Intent i = new Intent(this, Convertidor.class);
        startActivity(i);
    }
    //metodos para controlar ciclo actividad
    @Override protected void onResume() {
        super.onResume();
        //consultamos las preferencias....
        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);

        if (pref.getString("moneda1", "EUR").equals("AUD")){
            monedaOrigen = "AUD";
        }else if (pref.getString("moneda1", "EUR").equals("BRL")){
            monedaOrigen = "BRL";
        }else if (pref.getString("moneda1", "EUR").equals("GBP")){
            monedaOrigen = "GBP";
        }else if (pref.getString("moneda1", "EUR").equals("CAD")){
            monedaOrigen = "CAD";
        }else if (pref.getString("moneda1", "EUR").equals("CNY")){
            monedaOrigen = "CNY";
        }else if (pref.getString("moneda1", "EUR").equals("EUR")){
            monedaOrigen = "EUR";
        }else if (pref.getString("moneda1", "EUR").equals("HKD")){
            monedaOrigen = "HKD";
        }else if (pref.getString("moneda1", "EUR").equals("JPY")) {
            monedaOrigen = "JPY";
        }else if (pref.getString("moneda1", "EUR").equals("RUB")){
            monedaOrigen = "RUB";
        }else if (pref.getString("moneda1", "EUR").equals("USD")){
            monedaOrigen = "USD";
        }
        //elegimos moneda al cambio
        if (pref.getString("moneda2", "USD").equals("AUD")){
            monedaDestino = "AUD";
        }else if (pref.getString("moneda2", "USD").equals("BRL")){
            monedaDestino = "BRL";
        }else if (pref.getString("moneda2", "USD").equals("GBP")){
            monedaDestino = "GBP";
        }else if (pref.getString("moneda2", "USD").equals("CAD")){
            monedaDestino = "CAD";
        }else if (pref.getString("moneda2", "USD").equals("CNY")){
            monedaDestino = "CNY";
        }else if (pref.getString("moneda2", "USD").equals("EUR")){
            monedaDestino = "EUR";
        }else if (pref.getString("moneda2", "USD").equals("HKD")){
            monedaDestino = "HKD";
        }else if (pref.getString("moneda2", "USD").equals("JPY")) {
            monedaDestino = "JPY";
        }else if (pref.getString("moneda2", "USD").equals("RUB")){
            monedaDestino = "RUB";
        }else if (pref.getString("moneda2", "USD").equals("USD")){
            monedaDestino = "USD";
        }

        if (pref.getBoolean("musica", true)) {
            musica = true;
        } else {
            musica = false;
        }
        if (musica == true) mp.start();
    }
    @Override protected void onPause() {

        mp.pause();
        //Toast. makeText(this, "onPause", Toast.LENGTH_SHORT).show();
        super.onPause();
    }
    @Override
    protected void onStop(){
        mp.pause();
        //Toast. makeText(this, "onStop", Toast.LENGTH_SHORT).show();
        super.onStop();
    }
    @Override
    protected void onDestroy() {
        mp.pause();
        //Toast. makeText(this, "onDestroy", Toast.LENGTH_SHORT).show();
        super.onDestroy();
    }
    // guardamos estado actividad
    @Override protected void onSaveInstanceState(Bundle guardarEstado) {
        super.onSaveInstanceState(guardarEstado);

        if (mp != null) {
            pos = mp.getCurrentPosition();
            guardarEstado.putInt("posicion", pos);
        }
    }
    @Override protected void onRestoreInstanceState(Bundle recEstado) {

        super.onRestoreInstanceState(recEstado);

        if (recEstado != null && mp != null) {
            pos = recEstado.getInt("posicion");
            mp.seekTo(pos);
        }
    }
}
